new;
library qam,optmum,pgraph;

/*
**> Question 5
**
*/

let sigma = 0.10 0.20 0.15 0.25;
let rho =   1.0
            0.5 1.0
            0.5 0.5 1.0
            0.0 0.0 0.0 1.0;

rho = xpnd(rho);
cov = rho .* sigma .* sigma';
nAssets = rows(cov);

Bounds = 0~1;

{x,vol,retcode} = Qprog_Min_Variance(cov,ones(1,nAssets),1,0,0,Bounds .* ones(nAssets,1));
{vol,mr,tr,rc} = Compute_Risk_Contribution(x,cov);
result_mv = 100*(x~mr~tr~rc);

{x,vol,mr,tr,rc} = Compute_ERC_Portfolio(0,cov);
result_erc = 100*(x~mr~tr~rc);

{x,vol,mr,tr,rc} = Compute_MDP_Portfolio(0,cov);
result_mdp = 100*(x~mr~tr~rc);

x = ones(nAssets,1)/nAssets;
{vol,mr,tr,rc} = Compute_Risk_Contribution(x,cov);
result_ew = 100*(x~mr~tr~rc);

print ftosa(100*cov,"%lf",3,3);
print ftosa(result_mv,"%lf",3,2);
print ftosa(result_erc,"%lf",3,2);
print ftosa(result_mdp,"%lf",3,2);
print ftosa(result_ew,"%lf",3,2);

TexFile = "ex1.tex";
mask = 1;
let fmt[4,3] = 
               "%lf" 6 2
               "%lf" 6 2
               "%lf" 6 2
               "%lf" 6 2;

call Tabular(TeXFile,result_mv,mask,fmt,0,0,0,0,1);
call Tabular(TeXFile,result_erc,mask,fmt,0,0,0,0,0);
call Tabular(TeXFile,result_mdp,mask,fmt,0,0,0,0,0);
call Tabular(TeXFile,result_ew,mask,fmt,0,0,0,0,0);

     