new;
library qam,pgraph,optmum,option;

S0 = 100;
Kc = 1.02 * S0;
Kp = 0.98 * S0;
Tau = 1/12;
r = 0.00; b = 0.00;
Sigma = 0.20;

ST = 95~100~102;

_Option_Type = "call";
C0 = EuropeanBS(S0,Kc,sigma,tau,b,r);
CT = EuropeanPayOff(ST,Kc);
_Option_Type = "put";
P0 = EuropeanBS(S0,Kp,sigma,tau,b,r);
PT = EuropeanPayOff(ST,Kp);

print ftosa(C0,"CO = %lf",3,4);
print ftosa(P0,"PO = %lf",3,4);

PnL = (ST - S0) + (C0 - CT) + (PT - P0);
print PnL;

ST = 95~100~102;

tau = 1/24;
St = 103;

_Option_Type = "call";
Ct = EuropeanBS(St,Kc,sigma,tau,b,r);
_Option_Type = "put";
Pt = EuropeanBS(St,Kp,sigma,tau,b,r);

print ftosa(Ct,"Ct = %lf",3,4);
print ftosa(Pt,"Pt = %lf",3,4);

MtM = (St - S0) + (C0 - Ct) + (Pt - P0);
print MtM;

