new;
library qam,pgraph,optmum;

cls;

sigma1 = 0.15; sigma2 = 0.15; sigma3 = 0.05;
rho12 = 0.5; rho13 = 0.20; rho23 = 0.20;

sigma = sigma1 | sigma2 | sigma3;
rho = 1 | rho12 | 1 | rho13 | rho23 | 1;
rho = xpnd(rho);
cov = rho .* sigma .* sigma';

A = ones(1,3); B = 1; C = 0; D = 0; Bounds = (0~1) .* ones(3,1); Bounds[1,1] = 0.08;
{x0,sigma0,retcode} = Qprog_Min_Variance(cov,A,B,C,D,Bounds);
print x0;
print "var = " sqrt(x0'*cov*x0)^2;

xi = 0.08;
a = (1 - xi) * (sigma3^2 - rho23*sigma2*sigma3);
b = (1 - xi) * (sigma2^2 - rho23*sigma2*sigma3);
c = xi * sigma1 *(rho12 * sigma2 - rho13 * sigma3);
d = (sigma2^2 - 2*rho23*sigma2*sigma3 + sigma3^2);
x1 = xi;
x2 = (a - c)/d;
x3 = (b + c)/d;
print x1|x2|x3;

xi = 0.08;
a = sigma3^2 - rho23*sigma2*sigma3;
b = sigma2^2 - rho23*sigma2*sigma3;
c = sigma1 *(rho12 * sigma2 - rho13 * sigma3);
d = (sigma2^2 - 2*rho23*sigma2*sigma3 + sigma3^2);
a = a / d;
b = b / d;
c = c / d;
x1 = xi;
x2 = a - xi * (a + c);
x3 = b - xi * (b - c);

x = x1|x2|x3;
print x;
print "var = " sqrt(x'*cov*x)^2;

var = xi^2 * sigma1^2 + (a-(a+c)*xi)^2 * sigma2^2 + (b-(b-c)*xi)^2 * sigma3^2 +
      2*xi*(a-(a+c)*xi)*rho12*sigma1*sigma2 +
      2*xi*(b-(b-c)*xi)*rho13*sigma1*sigma3 +
      2*(a-(a+c)*xi)*(b-(b-c)*xi)*rho23*sigma2*sigma3;


print "var = " var;

alpha = sigma1^2 + (a+c)^2 * sigma2^2 + (b-c)^2 * sigma3^2 - 2*(a+c)*rho12*sigma1*sigma2 - 2*(b-c)*rho13*sigma1*sigma3 + 2*(a+c)*(b-c)*rho23*sigma2*sigma3;
beta =  a*rho12*sigma1*sigma2 + b*rho13*sigma1*sigma3 - (a*(b-c)+b*(a+c))*rho23*sigma2*sigma3 - a*(a+c)*sigma2^2 - b*(b-c)*sigma3^2;
gamma_ = a^2 * sigma2^2 + b^2 * sigma3^2 + 2*a*b*rho23*sigma2*sigma3;

var = alpha * xi^2 + 2 * beta * xi + gamma_;
print "var = " var;

sigma_star = 0.05;
polyroot(alpha|2*beta|(gamma_-sigma_star^2));